#include <stdio.h>
#include <stdlib.h>

#define MAX_TERMS 10 

//3ҽ < ε,  ε,  > 
typedef struct {  
  int row;    // ε
  int col;    // ε
  int value;  // 
} element;
 
typedef struct SparseMatrix {
  // Ŀ  
  int rows;   // 
  int cols;   // 
  int terms;  //0 ƴ  
  //0 ƴ ҵ ϴ ü 迭
  element data[MAX_TERMS];  
} SparseMatrix;

//  ϱ
void printSM(SparseMatrix temp){
  printf(" >>     << \n");   
  int r, c, i=0;
  for(r=0; r<temp.rows; r++)  {
    for(c=0; c<temp.cols; c++)
      if(r==temp.data[i].row && c==temp.data[i].col){  
        printf(" %3d", temp.data[i].value);
        i++;    
      }
      else{
        printf(" %3d", 0);       
      }   
    printf(" \n"); 
  }
}

//   ϱ
SparseMatrix addSM2(SparseMatrix a, SparseMatrix b)  
{ 
  //      ü  
  SparseMatrix c;
  // 迭 ׸ Ű ε
  int ca=0, cb=0, cc=0;
  //   ϱ ؼ   ũⰡ ƾ Ѵ.
  if( a.rows != b.rows || a.cols != b.cols ){
    fprintf(stderr," ũ⿡\n");
    exit(1);
  }
  //  ü    ũ⸦ 
  c.rows = a.rows;
  c.cols = a.cols;
  //0 ƴ    0 
  c.terms = 0;
  
  while( ca < a.terms && cb < b.terms ){
    //   ȣ Ѵ. 
    int inda = a.data[ca].row * a.cols + a.data[ca].col;
    int indb = b.data[cb].row * b.cols + b.data[cb].col;
    if( inda < indb) {       //迭 a Ұ տ 
      c.data[cc++] = a.data[ca++]; //迭 a Ҹ 迭 c 
    }
    else if( inda == indb ){ // a b  ġ
      c.data[cc].row = a.data[ca].row;
      c.data[cc].col = a.data[ca].col;
      c.data[cc++].value = a.data[ca++].value +
                           b.data[cb++].value;
    }
    else    //迭 b Ұ տ 
      c.data[cc++] = b.data[cb++];//迭 b Ҹ 迭 c 
  } //while
//  for(int i=0;i<10;i++)
  //迭 a b ִ Ҹ 迭 c 
  for(; ca < a.terms; ca++)
    c.data[cc++] = a.data[ca++];
  
  for(; cb < b.terms; cb++)
    c.data[cc++] = b.data[cb++];
  
  c.terms = cc;
  
  return c;
}

int main()
{
  SparseMatrix A={    3, 3, 3,
                   {{ 0, 1, 3}, 
                    { 1, 0, 8},
                    { 2, 2, 5 }
                   }
                 };

  SparseMatrix B={   3, 3, 1,  
                   {{ 1, 1, 3 }
                   }
                 };
  //     ü 
  SparseMatrix C;
  //   
  C = addSM2(A, B);
  //  
  printSM(A);   printSM(B);    printSM(C);
  
  getchar(); 
}
