#include <stdio.h>
#include <stdlib.h>

#define MAX_TERMS 10 

//3ҽ < ε,  ε,  > 
typedef struct {  
  int row;    // ε
  int col;    // ε
  int value;  // 
} element;
 
typedef struct SparseMatrix {
  // Ŀ  
  int rows;   // 
  int cols;   // 
  int terms;  //0 ƴ  
  //0 ƴ ҵ ϴ ü 迭
  element data[MAX_TERMS];  
} SparseMatrix;

//  ϱ
void printSM(SparseMatrix temp){
  printf(" >>    << \n");   
  int r, c, i=0;
  for(r=0; r<temp.rows; r++)  {
    for(c=0; c<temp.cols; c++)
      if(r==temp.data[i].row && c==temp.data[i].col){  
        printf(" %3d", temp.data[i].value);
        i++;    
      }
      else{
        printf(" %3d", 0);       
      }   
    printf(" \n"); 
  }
}

//  ġ  ϱ
SparseMatrix transpose(SparseMatrix a)  
{ 
  SparseMatrix b;

  //b   = a    
  b.rows = a.cols;
  //b   = a    
  b.cols = a.rows;
  
  //b 0 ƴ   
  //b 0 ƴ   
  b.terms = a.terms;
  
  if (a.terms > 0) {  // 0 ƴ  
    int CurrentB = 0;
    for (int c =0; c < a.cols; c++) //  ġ
      for (int i = 0; i < a.terms; i++)
        //  cκ Ҹ ã ̵Ų.
        if (a.data[i].col == c) {
          b.data[CurrentB].row = a.data[i].col;
          b.data[CurrentB].col = a.data[i].row;
          b.data[CurrentB].value = a.data[i].value;
          CurrentB++;
        }
  }// if (Terms >0) 
  return b;
}

int main()
{
  SparseMatrix A={    3, 3, 3,
                   {{ 0, 1, 3}, 
                    { 1, 0, 8},
                    { 2, 2, 5 }
                   }
                 };

  SparseMatrix B;

  B = transpose(A);
  
  //  
  printSM(A);   printSM(B);
  
  getchar(); 
}
