#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef int element;

typedef struct ListNode{
  //() 带 Ű ũ ʵ 
  struct ListNode* llink;
  // 带 ϴ  ʵ
  element data ;
  //(ļ) 带 Ű ũ ʵ 
  struct ListNode* rlink;  
} ListNode;

//   ü 
typedef struct{
	ListNode* head;
} linkedList_h;

//带  ϴ α׷
ListNode *getNode( )
{
	ListNode *newNode;
	newNode = (ListNode *)malloc(sizeof(ListNode)); 
	
  if(newNode == NULL){
		fprintf(stderr, "޸ Ҵ \n");
		exit(1);
	}
	
  return newNode;
}

// Ʈ ʱȭϴ Լ 
linkedList_h* createLinkedList_h(void)
{
  linkedList_h* L;
 
  //  Ȯ
  L = (linkedList_h*)malloc(sizeof(linkedList_h));  

  ListNode *newNode = getNode();
      
  L->head = newNode;
  L->head->llink = L->head;
  L->head->rlink = L->head;
 
  return L;
}

 // Ʈ ϴ Լ 
void printList(linkedList_h* L)
{
  ListNode* p;

  p = L->head->rlink;
  
  if(p == L->head){
    printf(" Ʈ");
    return;
  } 
  do{   
    printf("%5d", p->data);
    p = p->rlink;
  }while(p != L->head); 
  printf("\n");
} 

//  ˻ϴ Լ 
ListNode *findNode(linkedList_h* L, element x) 
{  
  ListNode *p;
  
  p = L->head->rlink;
      
  while(p != L->head){ //NULL ϸ ݺ  
    if(p->data == x)  //͸ ã 
      break;
    p = p->rlink;
  }     
  return p;
}

//ο 带 pre ʿ  
void dinsert(linkedList_h* L, ListNode *pre, element x)
{
  // ߰ 带  ޸Ҵ
  ListNode* newNode = getNode();

  newNode->data = x;     // ʵ忡   
  
  newNode->llink = pre;
  
  newNode->rlink = pre->rlink;
  
  pre->rlink->llink = newNode;   
  
  pre->rlink = newNode;     
}

// ϴ Լ
void ddelete(linkedList_h* L, ListNode* deleted) 
{   
  deleted->llink->rlink = deleted->rlink; 
  deleted->rlink->llink = deleted->llink; 
    
  free(deleted);              
}

int main(){
  linkedList_h* L;
  ListNode *p;
  
  L = createLinkedList_h();
  
  printf(" Ʈ ϱ! \n");
  printList(L); 
  
  printf(" Ʈ 3  ߰ϱ! \n");
  dinsert(L, L->head, 10);   dinsert(L, L->head, 20);   dinsert(L, L->head, 30);  
  printList(L);  
 
  printf("Ͱ 20  ġ ã 40 20 ڿ ϱ! \n"); 
  p = findNode(L, 20);
  dinsert(L, p, 40);
  printList(L);
  
  printf("Ͱ 20 ϱ! \n"); 
  ddelete(L, p);
  printList(L);

  getchar();
}
