#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef int element;

typedef struct ListNode{
  element data ;
  struct ListNode* link;
} ListNode;

typedef struct{
	ListNode* head;
} linkedList_h;

linkedList_h* createLinkedList_h(void)
{
  linkedList_h* L;
  L = (linkedList_h*)malloc(sizeof(linkedList_h));  
  L -> head = NULL;
  return L;
}

void addLastNode(linkedList_h* L, element x)
{
  ListNode* newNode;
  ListNode* p;
  
  newNode = (ListNode*)malloc(sizeof(ListNode));
    newNode->data=x;       // ʵ忡   
  newNode->link= NULL;   //ũ ʵ忡 NULL   
     
  if (L->head == NULL){  //ù ° ߰Ǵ Ͷ  
    L->head = newNode;
    return;
  }
  
  p = L->head;
  while (p->link != NULL) {// 尡 ƴϸ  ݺ 
    p = p->link; //ũ p ڽ  ϴ 带 Ű             
  }
  p->link = newNode;  
}

void printList(linkedList_h* L)
{
  ListNode* p;
  p= L->head;
  while(p != NULL){  
    printf("%5d", p->data);
    p = p->link;
  }
  printf("\n");
}

void removeNode(ListNode* prev, ListNode* p)
{
  if(p != NULL){         
    prev->link = p->link; 
    free(p);             
  }
}

// ü   Ѵ. 
int totalCount(linkedList_h* L)
{
  int count=0;
  ListNode *p=L->head;

  while( p != NULL ){
    count++;
    p = p->link;
  }

  return count;   
}

// Ư Ͱ    Ѵ. 
int count(linkedList_h* L, element x)
{
  int count=0;
  ListNode* p=L->head;

  while( p != NULL ){
    if( p->data == x ) 
      count++;
    p = p->link;
  }

  return count;
}

// Ʈ     Ѵ. 
int sum(linkedList_h* L)
{
  int total = 0;
  ListNode* p=L->head;
  
  while( p != NULL ){
    total += p->data;
    p = p->link;
  }

  return total;    
}

// Ʈ     ȣ · Ѵ.
int sumSelf(ListNode* p)
{
  int total = 0;
  
  if(p == NULL)
    return 0;
  else    
    return p->data + sumSelf(p->link);
}

// Ȧ   Ѵ.
void printOdd(linkedList_h* L)
{
  ListNode* p= L->head;
  while(p != NULL){  
    if( p->data % 2 == 1) 
      printf("%5d", p->data);
    p = p->link;
  }
  printf("\n");
}   

// ù ° 忡 ϳ ǳʼ ִ 带  Ѵ. 
// Ȧ ° ִ   Ѵ. 
void removeOdd(linkedList_h* L)
{
  ListNode *p, *prev=NULL;
  int count=0;
  p = L->head;
  while( p != NULL ){
    if( (count%2)!=0 ) {
      removeNode(prev, p);
      if( prev!= NULL ) 
        p=prev->link;
      else p=L->head;
    }
    else {
      prev=p;
      p = p->link;
    }
    count++;
  }  
} 

int main(){
  linkedList_h* L;
  L = createLinkedList_h();
  printf(" Ʈ ϱ! \n");
  printList(L); 
  
  printf("\n Ʈ  ߰ϱ! \n");
  addLastNode(L, 10);  addLastNode(L, 15);  addLastNode(L, 20); 
  addLastNode(L, 25);  addLastNode(L, 30);  addLastNode(L, 35);   
  addLastNode(L, 40);  addLastNode(L, 45);  addLastNode(L, 50); 
  addLastNode(L, 30);  addLastNode(L, 30);   
  printList(L);  
 
  printf("\n Ѱ : %5d \n", totalCount(L));

  printf("\nͰ 30   : %5d \n", count(L, 30));

  printf("\nƮ     : %5d \n", sum(L));
  
  printf("\nƮ    ( Լ) : %5d \n", sumSelf(L->head));
  
  printf("\nƮ Ȧ   \n");
  printOdd(L); 

  printf("\nƮ Ȧ °   \n");
  printf(" \n"); 
  printList(L); 
  removeOdd(L); 
  printf(" \n"); 
  printList(L); 
  
  getchar();
}
