#include <stdio.h>
int size;
void gapSort(int list[], int begin, int end, int gap)
{
	int i, j, item;
	for(i=begin+gap; i<=end; i=i+gap){
		item = list[i];
		for(j=i-gap; j>=begin && item<list[j]; j=j-gap)
			list[j+gap] = list[j];
		list[j+gap] = item;
	}
}

void shellSort(int list[],int size)
{
   int i, t, gap;
	 printf("\n\n----------- shell sorting --------------------");
     gap=size/2;
	 while(gap >= 1){		 	 
		 for (i=0; i<gap; i++)
			 gapSort(list, i, size-1, gap);	
		 printf("\n gap=%d  >> ", gap);
		 for(t=0; t<size; t++) printf("%d  ", list[t]);
		 printf("\n");
		 gap=gap/2;	
     }
}

int main()
{
	int list[8]={69, 10, 30, 2, 16, 8, 31, 22};
	int i;
	size = 8;	
	
  printf("----------- before shell sort ----------------\n");
	for(i=0; i<size; i++) 
    printf("  %d", list[i]);
	shellSort(list, size);
	
  printf("\n----------- after shell sort ----------------\n");
	for(i=0; i<size; i++) 
    printf("  %d", list[i]);	
	getchar();
}
