#include <stdio.h>
#include <stdlib.h>
#define MAX_VERTEX 30

typedef struct GraphType{
	int n;     //   
	int adjMatrix[MAX_VERTEX][MAX_VERTEX];	
} GraphType;
//׷ ʱȭ 
void createGraph(GraphType* g)
{
	int row, col;
	g->n = 0;
	for(row=0; row<MAX_VERTEX; row++) {	
		for(col=0; col<MAX_VERTEX; col++)
			g->adjMatrix[row][col]=0;			
	}
}
//   
void insertVertex(GraphType* g, int v)
{
	if(((g->n)+1)>MAX_VERTEX){
		printf("\n ׷   ʰϿϴ!");
		return;
	}
	g->n++;
}
//   
void insertEdge(GraphType* g, int u, int v)
{
	if(u>=g->n || v>=g->n) {
		printf("\n ׷  Դϴ!");
		return;
	}
	g->adjMatrix[u][v] = 1;	
}

void printAdjMatrix(GraphType* g)
{
	int row, col;
	for(row=0; row<(g->n);row++){
		printf("\n\t\t");
		for(col=0; col<(g->n);col++)
			printf("%2d", g->adjMatrix[row][col]);			
	}
}  

int main()
{
	int row;
	GraphType *G1, *G2; 
	G1 = (GraphType *)malloc(sizeof(GraphType));
	G2 = (GraphType *)malloc(sizeof(GraphType));

	createGraph(G1); 	
	//   
  for(row=0; row<4; row++)
		insertVertex(G1, row);
		
	insertEdge(G1, 0, 1);
  insertEdge(G1, 0, 2);	
	insertEdge(G1, 0, 3);
	insertEdge(G1, 1, 0);
	insertEdge(G1, 1, 2);
	insertEdge(G1, 2, 0);
	insertEdge(G1, 2, 1);
	insertEdge(G1, 2, 3);
	insertEdge(G1, 3, 2);
	insertEdge(G1, 3, 0);	
	insertEdge(G1, 3, 3);

	printf("\n G1  ");
	printAdjMatrix(G1);
		
	createGraph(G2); 
  //   
  for(row=0; row<4; row++)
		insertVertex(G2, row);
		
	insertEdge(G2, 0, 1);		
	insertEdge(G2, 0, 3);
	insertEdge(G2, 2, 3);
	insertEdge(G2, 3, 1);	
	
	printf("\n\n G2  ");
	printAdjMatrix(G2);

	getchar();
}
