#include <stdio.h>
#define TRUE 1
#define FALSE 0

#define VERTICES 7
#define INF 1000L

int adjMat[VERTICES][VERTICES]={
  //A   B    C    D    E    F    G      
{ 0,    13, INF, INF, INF,  19,  23},
{ 13,    0,  36, INF, INF, INF,  15}, 
{ INF,  36,   0,  12,  28, INF, INF},
{ INF, INF,  12,   0, INF,  32, INF},
{ INF, INF,  28, INF, INF,   0,  14},
{  19, INF, INF,  32,  14,   0,  20},
{  23,  15, INF, INF, INF,  20,   0}};

int selected[VERTICES];
int dist[VERTICES];

// ּ dist[v]    ȯ
int getMinVertex(int n)
{
  int v,i;
  for (i = 0; i <n; i++)
    if (!selected[i]) {
      v = i; 
	  break;
    }
  for (i = 0; i < n; i++)
    if ( !selected[i] && (dist[i] < dist[v])) v = i;
  return (v);
}

void prim(int s, int n)
{
	int i, u, v;

	for(u=0;u<n;u++)
		dist[u]=INF;
	dist[s]=0;
	for(i=0;i<n;i++){
		u = getMinVertex(n);
		selected[u]=TRUE;
		if( dist[u] == INF ) return;
		printf("%d ", u);
		for( v=0; v<n; v++)
			if( adjMat[u][v]!= INF)
				if( !selected[v] && adjMat[u][v]< dist[v] )
					dist[v] = adjMat[u][v];
	}
}

int main()
{
	prim(0, VERTICES);
	
	getchar();
}
