#include <stdio.h>
#include <stdlib.h>
#define MAX(a,b) ((a>b)?a:b)
#define MAX_TERMS 101

struct {
	float coef;
	int expon;
}  terms[MAX_TERMS]={ {2, 8}, {10, 5}, {-3, 3}, {1, 0}, 
                      {3, 2}, {1, 1}, {-4, 0} };
                      
int avail=7;

//ΰ   
char compare(int a, int b)
{
     if(a>b) return '>';
     else if(a==b) return '=';
     else return '<';
}
//ο  ׽ ߰
void attach(float coef, int expon)
{
     if(avail > MAX_TERMS){
          printf(" error :   ʹ ");   
          exit(1);
     }   
     terms[avail].coef=coef;
     terms[avail++].expon=expon;     
}
// C = A + B
void addPoly2(int sA, int fA, int sB, int fB, int *sC, int *fC)  
{	
	float tempcoef;
	*sC = avail;
	while( sA <= fA && sB <= fB )
	 switch(compare(terms[sA].expon,terms[sB].expon)){  
	    case '>': 	// A  > B 
		attach(terms[sA].coef, terms[sA].expon);
		sA++;			break;
  	    case '=': 	// A  == B 
		tempcoef = terms[sA].coef + terms[sB].coef;
		if( tempcoef ) 
		  attach(tempcoef,terms[sA].expon);
		sA++; sB++;		break;
  	    case '<': 	// A  < B 
		attach(terms[sB].coef, terms[sB].expon);
		sB++;			break;
	}
	// A  ׵ ̵
	for(;sA<=fA;sA++)
		attach(terms[sA].coef, terms[sA].expon);
	// B  ׵ ̵
	for(;sB<=fB;sB++)
		attach(terms[sB].coef, terms[sB].expon);
	*fC = avail -1;
}

void printPoly()
{
	int i;

	for(i=0; i<avail; i++){
       printf("%3.0fx^%d", terms[i].coef, terms[i].expon);
	   if(terms[i].expon==0)
	    	printf("\n");
    }
}

int main()
{
    int sC, fC;
    addPoly2(0, 3, 4, 6, &sC, &fC);
    printPoly();
    
	getchar();
}
