#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct ListNode{
  // 带 ϴ  ʵ
  int data ;
  // 带 Ű ũ ʵ 
  struct ListNode* link;
} ListNode;

//   ü 
typedef struct{
	ListNode* head;
} linkedList_h;

// Ʈ ʱȭϴ Լ 
linkedList_h* createLinkedList_h(void)
{
  linkedList_h* L;
    //  Ȯ
  L = (linkedList_h*)malloc(sizeof(linkedList_h));  
  L -> head = NULL;
  return L;
}

//带 ߰ϴ Լ 
void addLastNode(linkedList_h* L, int x)
{
  ListNode* newNode;
  ListNode* p;
  
  // ߰ 带  ޸Ҵ
  newNode = (ListNode*)malloc(sizeof(ListNode));
  newNode->data=x;       // ʵ忡   
  newNode->link= NULL;   //ũ ʵ忡 NULL   
     
  if (L->head == NULL){  //ù ° ߰Ǵ Ͷ  
    L->head = newNode;
    return;
  }
  
  p = L->head;
  while (p->link != NULL) {// 尡 ƴϸ  ݺ 
    p = p->link; //ũ p ڽ  ϴ 带 Ű             
  }
  p->link = newNode;  
}

// Ʈ ϴ Լ 
void printList(linkedList_h* L)
{
  ListNode* p;
  p= L->head;
  while(p != NULL){  
    printf("%5d", p->data);
    p = p->link;
  }
  printf("\n");
}

//ḮƮ پ  ߰ϱ
// ϴ Լ
void insertAfter(linkedList_h* L, int x, ListNode *p) 
{ 
  ListNode* newNode;
 
  // ߰ 带  ޸Ҵ
  newNode = (ListNode*)malloc(sizeof(ListNode));
  newNode->data=x;       // ʵ忡   
      
  if (L->head == NULL){  //ù ° ߰Ǵ Ͷ  
    newNode->link = NULL; //ũ ʵ忡 NULL   
    L->head = newNode;
  }
  else if(p == NULL){  //p NULL̸ ù °   
    L->head = newNode;
  }else{  //p   
    newNode->link = p->link;          
    p->link = newNode;  
  }                 
}

//  ˻ϴ Լ 
ListNode *findNode(linkedList_h* L, int x) 
{  
  ListNode *p;
  p = L->head;    //ũ Ʈ ó  head->link s ʱⰪ 
  while( p != NULL ){ //NULL ϸ ݺ  
   if(p->data == x)   //͸ ã 
      break;
    p = p->link;
  }     
  return p;
}

//  ϱ 
void deleteLastNode(linkedList_h* L){
  ListNode* previous;
  ListNode* current;
  
  if (L->head == NULL) return;
  if (L->head->link == NULL) {
    free(L->head);
    L->head = NULL;
    return;
  }
  else {
    previous = L->head;
    current = L->head->link;
    while(current ->link != NULL){
      previous = current;
      current = current->link;
    }
  free(current);
  previous->link = NULL;
  }
}

// ϴ Լ
int deleteNode(linkedList_h* L, int x) 
{ 
  ListNode* previous;
  ListNode* current;

  if(L->head == NULL)
    return 0;
    
  previous = L->head; 
  current = previous->link;
  while(previous != NULL){
    if(current->data == x)
      break;
    previous = previous->link;          
    current = previous->link;
  }
  
  if(current != NULL){          //p tail ƴϸ Ŷ ã 
    previous->link = current->link; //prev   p  尡 
    free(current);              //p Ű 带 ޸ 
    return 1; // ϿǷ 1 ǵ
  }
  else  //p NULL̸ Ŷ ã  
    return 0; // ϿǷ 0 ǵ
}

// ȸϴ Լ  
void reverse(linkedList_h * L){
  ListNode* p;
  ListNode* q;
  ListNode* r;

  p = L->head;
  q=NULL;
  r=NULL;

  while (p!= NULL){
    r = q;
    q = p;
    p = p->link;
    q->link = r;
  }
  L->head = q;
}

//  ϱ
void freeLinkedList_h(linkedList_h* L){
  ListNode* p;
  while(L->head != NULL){
    p = L->head;
    L->head = L->head->link;
    free(p);
    p=NULL;
  }
}

int main(){
  linkedList_h* L;
  ListNode* p;
  
  L = createLinkedList_h();
  
  printf("Ʈ  ߰ϱ! \n");
  addLastNode(L, 10);   addLastNode(L, 20);   addLastNode(L, 40); 
  addLastNode(L, 50);   addLastNode(L, 60);   addLastNode(L, 70);      
  printList(L);

  printf("Ͱ 20  ġ ã 30 20 ڿ ϱ! \n"); 
  p=findNode(L, 20);
  insertAfter(L, 30, p);
  printList(L);
  
  printf("Ͱ 20 ϱ! \n"); 
  deleteNode(L, 20);
  printList(L);

  printf("  ϱ! \n");
  deleteLastNode(L);
  printList(L);
  
  printf("Ʈ Ҹ  ȯϱ! \n");
  reverse(L);  
  printList(L); 

  printf("Ʈ ϱ!\n");
  freeLinkedList_h(L);
  printList(L);

  getchar();
  return 0;
}
