#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef int element;

typedef struct ListNode{
  // 带 ϴ  ʵ
  element data ;
  // 带 Ű ũ ʵ 
  struct ListNode* link;
} ListNode;

//   ü 
typedef struct{
	ListNode* head;
} linkedList_h;

// Ʈ ʱȭϴ Լ 
linkedList_h* createLinkedList_h(void)
{
  linkedList_h* L;
 
  //  Ȯ
  L = (linkedList_h*)malloc(sizeof(linkedList_h));  
  L -> head = NULL;
  
  return L;
}

 // Ʈ ϴ Լ 
void printList(linkedList_h* L)
{
  ListNode* p;
  
  if(L->head == NULL) return;
  
  p = L->head;
  
  do{   
    printf("%5d", p->data);
    p = p->link;
  }while(p != L->head); 
  printf("\n");
} 


//带  ϴ α׷
ListNode *getNode( )
{
	ListNode *newNode;
	newNode = (ListNode *)malloc(sizeof(ListNode)); 
	
  if(newNode == NULL){
		fprintf(stderr, "޸ Ҵ \n");
		exit(1);
	}
	
  return newNode;
}

//  Ʈ ó 带 ϴ Լ  
void addFrontNode(linkedList_h* L, element x)
{
  ListNode* newNode;
  ListNode* p;  
  
  newNode = getNode();      
  newNode->data = x;   // ʵ忡   
  
  if(L->head == NULL){  //ù ° ߰Ǵ Ͷ  
    L->head = newNode;
    newNode->link = newNode;
  }  
  else{
    p = L->head;
    while(p->link != L->head) 
      p=p->link;
      
    newNode->link = p->link;
    p->link = newNode; 
    L->head = newNode;        
  }
}

//  ˻ϴ Լ 
ListNode *findNode(linkedList_h* L, element x) 
{  
  ListNode *p;
  
  p = L->head;    
  while( p != NULL ){ //NULL ϸ ݺ  
    if(p->data == x)   //͸ ã 
      break;
    p = p->link;
  }     
  return p;
}

//  Ʈ  带 ϴ Լ  
void insertMiddleNode(linkedList_h* L, ListNode *pre, element x)
{
  ListNode* newNode;
  ListNode* p;
  // ߰ 带  ޸Ҵ
  newNode = getNode();
  newNode->data = x;     // ʵ忡   
     
  if(L->head == NULL){  //ù ° ߰Ǵ Ͷ  
    L->head = newNode;
    newNode->link = newNode;
  }  
  else{
    newNode->link = pre->link;
    pre->link = newNode;    
  }
}

int main(){
  linkedList_h* L;
  ListNode *p;
  
  L = createLinkedList_h();
  
  printf(" Ʈ ϱ! \n");
  printList(L); 
  
  printf(" Ʈ 3  ߰ϱ! \n");
  addFrontNode(L, 10);   addFrontNode(L, 20);   addFrontNode(L, 30);  
  printList(L);  
  
  printf(" Ʈ ó  Ѱ ߰ϱ! \n");
  addFrontNode(L, 40);     
  printList(L);
  
  printf("Ͱ 30  ġ ã 50 30 ڿ ϱ! \n"); 
  p = findNode(L, 30);
  insertMiddleNode(L, p, 50);
  printList(L);
  
  getchar();
}
