#include <stdio.h>
#include <stdlib.h>

typedef struct ListNode{
  float coef;
  int expo;
  struct ListNode* link;
} ListNode;

typedef struct ListHead{
  ListNode* head;
} ListHead;


ListHead* createLinkedList(void)
{
  ListHead* L;
  L = (ListHead *)malloc(sizeof(ListHead));
  L->head = NULL;
  return L;
}

void addLastNode(ListHead* L, float coef, int expo)
{
  ListNode* newNode;
  ListNode* p;
  // ߰ 带  ޸Ҵ
  newNode = (ListNode *)malloc(sizeof(ListNode));
  newNode->coef = coef; //coef ʵ忡   
  newNode->expo = expo; //expo ʵ忡   
  newNode->link = NULL; //ũ ʵ忡 NULL   

  //  Ʈ̸ ߰Ǵ ͸ head Ű Ѵ.  
  if(L->head == NULL){
    L->head = newNode;
    return;
  }
  //̹ ߰ 尡 Ѵٸ
  p = L->head; //p head Ű  , ù ° 带 Ŵ

  while(p->link != NULL) {// 尡 ƴϸ  ݺ 
    p = p->link;//ũ p ڽ  带 Ŵ
  }
  p->link = newNode;
}


void addPoly(ListHead* A, ListHead* B, ListHead* C)
{
  ListNode* pA = A->head;
  ListNode* pB = B->head;
  float sum; 

  while(pA && pB){
   //    
   if(pA->expo == pB->expo){
      sum = pA->coef + pB->coef;  //    
      //׽ C(X)  ߰      
      addLastNode(C, sum, pA->expo); 
      // pA pB    ̵
      pA=pA->link;   pB=pB->link;
    }
    //pA     
    else if(pA->expo < pB->expo){      
      // pB Ű ׽ B(x)  C(x)  Ѵ.
      addLastNode(C, pB->coef, pB->expo);

      // pB Ű ׿  ó Ƿ pB   ̵Ѵ.
      pB=pB->link;
    }
    //pA   ū 
    else {   
      // pA Ű ׽ A(x)  C(x)  Ѵ.
      addLastNode(C, pA->coef, pA->expo);
      // pA Ű ׿  ó Ƿ pA   ̵Ѵ. 
      pA=pA->link;  
    }
  } 
  //׽ A(x)  ׵ Ѵ.
  for( ; pA!=NULL; pA=pA->link)
    addLastNode(C, pA->coef, pA->expo);
  //׽ B(x)  ׵ Ѵ.
  for( ; pB!=NULL; pB=pB->link)
    addLastNode(C, pB->coef, pB->expo);
}

void printPoly(ListHead* L)
{
  ListNode* p = L->head;
  for(;p;p=p->link){              
    printf("%3.0fx^%d", p->coef, p->expo);
  }
}

int main(){
  ListHead *A, *B, *C;

  A = createLinkedList();
  B = createLinkedList();
  C = createLinkedList();

  addLastNode(A, 3, 14);
  addLastNode(A, 2, 8);
  addLastNode(A, 1, 0);
  printf("\n A(x)=");
  printPoly(A);

  addLastNode(B, 8, 14);
  addLastNode(B, -3, 10);
  addLastNode(B, 10, 6);
  printf("\n B(x)=");
  printPoly(B);

  addPoly(A, B, C);
  printf("\n C(x)=");
  printPoly(C);

  getchar();
}
