#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef int element;

typedef struct ListNode{
  element data ;
  struct ListNode* link;
} ListNode;

typedef struct{
	ListNode* head;
} linkedList_h;

linkedList_h* createLinkedList_h(void)
{
  linkedList_h* L;
  L = (linkedList_h*)malloc(sizeof(linkedList_h));  
  L -> head = NULL;
  return L;
}

void addLastNode(linkedList_h* L, element x)
{
  ListNode* newNode;
  ListNode* p;
  
  newNode = (ListNode*)malloc(sizeof(ListNode));
    newNode->data=x;       // ʵ忡   
  newNode->link= NULL;   //ũ ʵ忡 NULL   
     
  if (L->head == NULL){  //ù ° ߰Ǵ Ͷ  
    L->head = newNode;
    return;
  }
  
  p = L->head;
  while (p->link != NULL) {// 尡 ƴϸ  ݺ 
    p = p->link; //ũ p ڽ  ϴ 带 Ű             
  }
  p->link = newNode;  
}

void printList(linkedList_h* L)
{
  ListNode* p;
  p= L->head;
  while(p != NULL){  
    printf("%5d", p->data);
    p = p->link;
  }
  printf("\n");
}

void removeNode(ListNode* prev, ListNode* p)
{
  if(p != NULL){         
    prev->link = p->link; 
    free(p);             
  }
}

void searchRemove(linkedList_h* L, element x)
{
	ListNode *p, *prev=NULL;
	p = L->head;
	while( p != NULL ){
		if( p->data == x ) {
			
      removeNode(prev, p);
			break;
		}
		else {
			prev=p;
			p = p->link;
		}
	}
}

int main(){
  linkedList_h* L;
  L = createLinkedList_h();
  printf(" Ʈ ϱ! \n");
  printList(L); 
  
  printf(" Ʈ 4  ߰ϱ! \n");
  addLastNode(L, 10);   addLastNode(L, 20);   
  addLastNode(L, 30);   addLastNode(L, 40); 
  printList(L);  
  
  printf("Ͱ 20 ϱ! \n"); 
  searchRemove(L, 20);
  printList(L); 
  getchar();
}
