#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef char* element;

//a.  ϴ  Ʈ ϱ  ü 
typedef struct ListNode{
  char data[5];
  struct ListNode* link;
} ListNode;

typedef struct{
	ListNode* head;
} linkedList_h;

linkedList_h* createLinkedList_h(void)
{
  linkedList_h* L;
  L = (linkedList_h*)malloc(sizeof(linkedList_h));  
  L->head = NULL;
  return L;
}

//b.  ߰ϴ Լ
void addLastNode(linkedList_h* L, element x)
{
  ListNode* newNode;
  ListNode* p;
  
  newNode = (ListNode *)malloc(sizeof(ListNode)); 

  strcpy(newNode->data, x);  // ʵ忡   
  
  newNode->link= NULL;    
     
  if (L->head == NULL){  
    L->head = newNode;     
    return;
  }
  
  p = L->head;
 
  while (p->link != NULL) {    
    p = p->link;         
  }
  p->link = newNode;  
}

//c.  Ʈ   
void printList(linkedList_h* L)
{
  ListNode* p;
  p= L->head;
  
  while(p != NULL){  
    printf("%5s", p->data);
    p = p->link;
  }
  printf("\n");
}

void removeNode(ListNode* prev, ListNode* p)
{
  if(p != NULL){         
    prev->link = p->link; 
    free(p);             
  }
}

//d. Ư   Ʈ 
void searchRemove(linkedList_h* L, element x)
{
  ListNode *p, *prev=NULL;
  p = L->head;    
  while(p != NULL){   
    if(strcmp(p->data, x)==0) { 
      removeNode(prev, p); 
      break;                
    }
    else {
      prev=p;
      p = p->link;
    }
  }
}

int main(){
  linkedList_h* L;
  L = createLinkedList_h();
  printf(" Ʈ ϱ! \n");
  printList(L); 
  
  printf("\n Ʈ  ߰ϱ! \n");
  // (, , , ) ߰
  addLastNode(L, ""); addLastNode(L, "");  
  addLastNode(L, ""); addLastNode(L, ""); 
  //c.  Ʈ   
  printList(L); 
  printf("\nݿ  Ʈ ϱ! \n"); 
  //d. ݿ  Ʈ   
  searchRemove(L, "");
  printList(L); 

  getchar();
}
