#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 

typedef char element;

typedef struct StackNode {      
  element data; 
  // 带 Ű   
  struct StackNode *link;   
}StackNode; 

StackNode* top;
//   true, ƴϸ false ȯ 
int isEmpty()
{
  //top Ͱ NULL̸  ִ ̴. 
  return (top == NULL);
}

// TOP Ҹ  
void push(element item) 
{  
  //ο   ȮѴ. 
  StackNode* temp=(StackNode *)malloc(sizeof(StackNode));
  //Լ ޵   
  temp->data = item; 
  //ο 尡   ù 带 Ű Ѵ. 
  temp->link = top;  
  //top ο 带 Ű Ѵ.  
  top = temp; 
} 
// TOP Ҹ  
element pop() 
{ 
  element item;
  StackNode* temp=top;
  //    
  if(top == NULL) {    
    printf("\n\n Stack is empty !\n");   
    return 0; 
  } 
  else { 
    // top ͸  
    item = temp->data;  
    //top  带 Ű Ѵ.  
    top = temp->link;   
    // top   ݳѴ. 
    free(temp);        
    // top ͸ Ѵ. 
    return item; 
  } 
} 

element peek() 
{  
  element item; 
  if(top == NULL) {     
    printf("\n\n Stack is empty !\n");   
    return 0;   
  } 
  else { 
    item = top->data; 
    return item; 
  } 
} 

//, ǿ, ȣ óϱ   Ÿ precedence   
typedef enum{lparen, rparen, plus, minus, multiply, 
             divide, mod, eos, operand} precedence;

precedence getToken(char ch)
{
  precedence token;
  switch(ch){
    case '('  : token=lparen;   break;
    case ')'  : token=rparen;   break;         
    case '+'  : token=plus;     break;
    case '-'  : token=minus;    break;
    case '*'  : token=multiply; break;
    case '/'  : token=divide;   break;
    case '%'  : token=mod;      break;
    case NULL : token=eos;      break;
    default   : token=operand;  //⺻  ǿ 
  } 
  return token;         
} 
    
char printToken(precedence token)
{
  char ch;
  switch(token){
      case lparen   : ch='('; break;
      case rparen   : ch=')'; break;         
      case plus     : ch='+'; break;
      case minus    : ch='-'; break;
      case multiply : ch='*'; break;
      case divide   : ch='/'; break;
      case mod      : ch='%'; break;
  } 
  return ch;    
}    

int prec(precedence symbol){
  switch(symbol){
    case lparen   : 
    case rparen   : return 0;         
    case plus     : 
    case minus    : return 1;   
    case multiply : 
    case divide   : 
    case mod      : return 2;  
  } 
}

char* toPostfix(char *exp)
{
  static char postExpr[256]="";
  int len=0;
  precedence token;     //  ϴ   
  char  symbol;
  int opr1, opr2;
  int n=0; // Ʈ īƮϱ   
  
  top = NULL;
  
  symbol = exp[n];
  token = getToken(symbol); 
  
  while(token != eos){
    if(token == operand){
      postExpr[len++]=symbol;
      postExpr[len]='\0';     
    }//if 
    else if(token == lparen){
      push(symbol); // ȣ  ÿ  
    }    
    else if(token == rparen){ // ȣ̸  
      // ȣ   ū Ͽ    
      while(getToken(peek()) != lparen){                      
        postExpr[len++]=pop();
        postExpr[len]='\0'; 
      }
      pop();  // ȣ .      
    }//else if    
    else{
      //ÿ   켱   
      while(isEmpty() == false && prec(getToken(peek())) >= prec(token)){
        postExpr[len++]=pop();
        postExpr[len]='\0'; 
      }
      push(symbol);
    }//esle
    symbol = exp[++n];
    token = getToken(exp[n]);        
  }//while
 
  while( isEmpty() == false )
    postExpr[len++]=pop();
    
  postExpr[len]='\0';

  return postExpr;
}

int main(void) 
{     
  int result;
  char* x1= "a+b*c";
  char* x2= "(a+b)*c";
  char* x3= "a*(b+c)*d";
  char* postExpr;

  postExpr= toPostfix(x1);
  printf("\n %s ǥ : %s", x1, postExpr);

  postExpr= toPostfix(x2);
  printf("\n %s ǥ : %s", x2, postExpr);
  
  postExpr= toPostfix(x3);
  printf("\n %s ǥ : %s", x3, postExpr);

  getchar();
} 
