#include <stdio.h>
#include <stdlib.h>
#define MAX_QUEUE_SIZE   8   

typedef char element; 
typedef struct{
  element queue[MAX_QUEUE_SIZE];
  int front, rear;
} QueueType;

QueueType *createQueue()
{
  QueueType *cQ;
  cQ = (QueueType *)malloc(sizeof(QueueType));
  cQ->front=0;
  cQ->rear=0;
  return cQ;
}

int isEmpty(QueueType *cQ) 
{ 
  if (cQ->front == cQ->rear) 
    return 1;   
  else 
   return 0; 
} 

int isFull(QueueType *cQ) 
{ 
  if (((cQ->rear + 1) % MAX_QUEUE_SIZE) == cQ->front) 
    return 1;   
  else 
    return 0; 
}

void enQueue(QueueType *cQ, element item) 
{ 
   if(isFull(cQ)) 
     exit(1); 
   else  {
     // rear  Ͽ  ڸ غ 
     cQ->rear = (cQ->rear + 1) % MAX_QUEUE_SIZE;
     // غ ڸ cQ[rear]  item 
     cQ->queue[cQ->rear] = item;
   }
}


element deQueue(QueueType *cQ) 
{ 
   if (isEmpty(cQ)) exit(1); 
   else {
     // front  Ͽ  ڸ غ 
     cQ->front = (cQ->front + 1) % MAX_QUEUE_SIZE;
     // غ ڸ ִ  cQ[front] Ͽ ȯ
     return cQ->queue[cQ->front]; 
   }
} 

int main(void) 
{ 
  QueueType *cQ1 = createQueue(); 
  element data; 
  enQueue(cQ1, 'A');   enQueue(cQ1, 'B'); enQueue(cQ1, 'C');  
    
  while(isEmpty(cQ1) == false)
    printf(" %c\t", deQueue(cQ1));

  getchar();
} 
