#include <stdio.h>
#include <malloc.h>

typedef char element; 
typedef struct QueueNode{
	element data;
	struct QueueNode *link;
} QueueNode;

typedef struct{	
	QueueNode *front, *rear;
} LQueueType;

LQueueType *createLinkedQueue()
{
	LQueueType *LQ;
	LQ = (LQueueType *)malloc(sizeof(LQueueType));
	LQ->front=NULL;
	LQ->rear=NULL;
	return LQ;
}

int isEmpty(LQueueType *LQ) 
{ 
	if (LQ->front == NULL)		
		return 1;	 
	else 
    return 0; 
} 

void enQueue(LQueueType *LQ, element item) 
{ 
	 QueueNode *newNode=(QueueNode *)malloc(sizeof(QueueNode));
	 newNode->data = item;
	 newNode->link = NULL;
	 if(LQ->front == NULL) {
		 LQ->front = newNode;
		 LQ->rear = newNode;		
	 }
	 else {
		LQ->rear->link = newNode;
		LQ->rear = newNode;
	 }
}

element deQueue(LQueueType *LQ) 
{ 
	QueueNode *old = LQ->front;
	element item;
	if (isEmpty(LQ)) 
    return 0; 
	else {
		item = old->data;
		LQ->front = LQ->front->link; 
		if(LQ->front == NULL) 
			LQ->rear = NULL;
		free(old);
		return item;
	}
} 

element peek(LQueueType *LQ) 
{ 
	 element item;
	 if (isEmpty(LQ)) 
     return 0; 
	 else {
		 item = LQ->front->data;
		 return item;
	 }
}

int main(void) 
{ 
	LQueueType *LQ1 = createLinkedQueue(); 
	enQueue(LQ1, 'A'); 	enQueue(LQ1, 'B');  	enQueue(LQ1, 'C');
	
  while(isEmpty(LQ1) == false)
    printf(" %c\t", deQueue(LQ1));

	getchar();
} 
