#include <stdio.h>
#define MAX  30

int size;
int sorted[MAX];
// 2  迭 list[left..mid] list[mid+1..right] պ
void merge(int list[], int left, int middle, int right)
{
	int i, j, k, t;
	i = left; 
	j = middle+1;
	k = left;

	while (i<=middle && j<=right){
		if(list[i]<=list[j]){
			sorted[k]=list[i];
			i++; 
		}
		else{
			sorted[k]=list[j];
			j++; 
		}
		k++;
	}
	if(i>middle)
		for(t=j; t<=right; t++,k++)
			sorted[k]=list[t];
	else
		for(t=i; t<=middle; t++,k++)
			sorted[k]=list[t];
	for(t=left; t<=right; t++)
		list[t] = sorted[t];
	printf("\n >> ");
  for(t=0; t<size; t++) 
     printf("%d  ", list[t]);
}

void mergeSort(int list[], int left, int right)
{
	int middle, t;
	
	if(left<right){
		middle = (left+right)/2;          //Ʈ յ  
		mergeSort(list, left, middle);    //κ Ʈ  
		mergeSort(list, middle+1, right); //κ Ʈ 
		merge(list, left, middle, right);
	}
}

int main()
{
	int i;
	int list[8]={32, 20, 11, 26, 78, 43, 56, 18};
	size = 8;	
	printf("------------------ before merge sort ------------------\n");
  for(i=0; i<size; i++) 
    printf("%d  ", list[i]);
  printf("\n\n------------------ merge sorting --------------------\n");
	mergeSort(list, 0, size-1);                

  printf("\n\n------------------ after merge sort ------------------\n");
  for(i=0; i<size; i++) 
    printf("%d  ", list[i]);
	
	getchar();
}
