#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>

#define MAX_WORD_LENGTH 20
#define MAX_MEAN_LENGTH 200

//  
typedef struct {
  char word[MAX_WORD_LENGTH];
  char mean[MAX_MEAN_LENGTH];
} element;
//  
typedef struct treeNode{
  element key;
  struct treeNode *left;
  struct treeNode *right;
} treeNode;
// Ž Ʈ Ž Լ 
treeNode* searchBST(treeNode* root, element key) 
{    
  treeNode* p;   int compare;
  p = root; 
  while (p != NULL){ 
    compare = strcmp(key.word, p->key.word);
    if(compare < 0) {
      p = p->left; 
    }
    else if(compare > 0) {
      p = p->right; 
    }
    else {
      printf("ã ܾ : %s", p->key.word); 
      return p; 
    }
  }
  return p;   //Ž   NULL ȯ   
} 
//Ű  Ž Ʈ Ѵ. ϴ Ű   
treeNode* insertKey(treeNode *p, element key) 
{ 
  treeNode *newNode;  //ο  
  int compare;  
  if (p == NULL) { 
      newNode = (treeNode*)malloc(sizeof(treeNode)); 
      newNode->key = key; 
      newNode->left = NULL; 
      newNode->right = NULL; 
      return newNode; 
  } 
  else { 
    compare = strcmp(key.word, p->key.word);
    if(compare < 0) {
      p->left = insertKey(p->left, key);
      return p; 
    }
    else if(compare > 0){
      p->right = insertKey(p->right, key); 
      return p; 
    }
    else {
      printf("\n ̹  ܾ ֽϴ! \n"); 
      return p; 
    } 
  }
} 

void insert(treeNode** root, element key) 
{ 
  *root = insertKey(*root, key); 
} 
// Լ 
void deleteNode(treeNode *root, element key)
{
  treeNode *parent, *p, *succ, *succ_parent;
  treeNode *child;
  //Ű   p Ž parent p θ  
  parent=NULL;
  p=root; 
  while((p != NULL) && (strcmp(p->key.word, key.word)!=0)){
    parent=p;
    if(strcmp(key.word, p->key.word)<0)
      p=p->left;
    else p=p->right;
  }
  if(p == NULL){ //Ž Ʈ  Ű 
    printf("\n ã Ű Ʈ ϴ!!");
    return;
  }
  //ܸ 
  if((p->left == NULL) && (p->right == NULL)){
    if(parent != NULL){
      if(parent->left == p) parent->left=NULL;
      else parent->right=NULL;
    }
    else root=NULL;
  }
  //ڽĳ尡    
  else if((p->left == NULL) || (p->right == NULL)){
    if(p->left != NULL) child=p->left;
    else child=p->right;
    if(parent != NULL){
      if(parent->left == p) parent->left=child;
      else parent->right=child;
    }
    else root=child;
  }
  //ڽĳ尡    
  else{
    succ_parent=p;
    succ=p->right;
    while(succ->left != NULL){
      succ_parent=succ;
      succ=succ->left;
    }
    if(succ_parent->left == succ) 
      succ_parent->left=succ->right;
    else succ_parent->right=succ->right;
    p->key=succ->key;
    p=succ;
  } 
  free(p);
}
// Ž Ʈ  Լ 
void inorderDisplay(treeNode* root)
{
  if(root){
    inorderDisplay(root->left);
    printf(" %s \t : %s \n", root->key.word, root->key.mean);
    inorderDisplay(root->right);
  }
}

void menu()
{
  element e;
  treeNode *root=NULL, *temp;
  char choice;
   printf("\n 1 : Է");
  printf("   2 : ");
  printf("   3 : ˻");
  printf("   4 : ");
  printf("   5 : ");
do{
  printf("\n\n # ۾ ϼ >>___\b\b");
  choice = getchar();  getchar();
  printf("\n");
  switch(choice){
    case '1' :    
      printf("ܾ Է >> ");  gets(e.word);
      printf("ܾ  Է >> ");  gets(e.mean);
      insert(&root, e);
      break;
    case '2' :    
      printf(" ܾ Է >> ");  gets(e.word);
      deleteNode(root, e);
      break;
    case '3' :      
      printf("˻ ܾ Է >> ");  gets(e.word);      
      temp=searchBST(root, e);
      if(temp != NULL)
        printf("\nܾ  : %s", temp->key.mean);
      else printf("\n  ܾԴϴ.");
      break;
    case '4' :
      inorderDisplay(root); 
      break;
    }
  }while((choice-'0') != 5);
}

int main()
{
  menu();
  
  getchar();
}

  
